
Name:      qubes-mgmt-salt-dom0-virtual-machines
Version:   4.1.20
Release:   1%{?dist}
Summary:   Downloads, installs and configures template as well as creating and configuring virtual-machine AppVM's.
License:   GPL 2.0
URL:	   http://www.qubes-os.org/

Group:     System administration tools
BuildArch: noarch
BuildRequires: make
Requires:  qubes-mgmt-salt
Requires:  qubes-mgmt-salt-dom0
Requires:  qubes-core-admin-addon-whonix
# do not require qubes-core-dom0 directly, but if installed, make sure it's the
# right version
Conflicts: qubes-core-dom0 < 4.0.35

Source0: %{name}-%{version}.tar.gz

%description
Downloads, installs and configures template as well as creating and configuring virtual-machine AppVM's.
Uses pillar data to define default VM names and configuration details.

%prep
%setup -q

%build

%install
make install DESTDIR=%{buildroot} LIBDIR=%{_libdir} BINDIR=%{_bindir} SBINDIR=%{_sbindir} SYSCONFDIR=%{_sysconfdir}

%pre

if [ $1 -ge 2 ] && ! [ -e /srv/formulas/base/virtual-machines-formula/qvm/default-mgmt-dvm.sls ]; then
    touch /var/run/%{name}-default-mgmt-dvm-firstinstall
fi

%post
# Enable Pillar States
qubesctl top.enable qvm pillar=true -l quiet --out quiet > /dev/null || true

# Migrate enabled tops from dom0 to base environment
for top in sys-net sys-firewall sys-whonix anon-whonix personal work untrusted vault sys-usb sys-net-with-usb; do
    if [ -h /srv/salt/_tops/dom0/qvm.$top.top ]; then
        rm -f /srv/salt/_tops/dom0/qvm.$top.top
        qubesctl top.enable qvm.$top -l quiet --out quiet > /dev/null || true
    fi
done

if [ -r /srv/pillar/_tops/dom0/qvm.top ]; then
    rm -f /srv/pillar/_tops/dom0/qvm.top
fi

%posttrans

if [ -e /var/run/%{name}-default-mgmt-dvm-firstinstall ]; then
    # create default-mgmt-dvm on update, see QSB#45
    qubesctl state.sls qvm.default-mgmt-dvm
    rm /var/run/%{name}-default-mgmt-dvm-firstinstall
fi

%files
%defattr(-,root,root)
%doc LICENSE README.md
%attr(750, root, root) %dir /srv/formulas/base/virtual-machines-formula
/srv/formulas/base/virtual-machines-formula/README.md
/srv/formulas/base/virtual-machines-formula/LICENSE
/srv/formulas/base/virtual-machines-formula/qvm/anon-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/anon-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/default-dispvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/default-dispvm.top
/srv/formulas/base/virtual-machines-formula/qvm/default-guivm.sls
/srv/formulas/base/virtual-machines-formula/qvm/default-guivm.top
/srv/formulas/base/virtual-machines-formula/qvm/default-audiovm.sls
/srv/formulas/base/virtual-machines-formula/qvm/default-audiovm.top
/srv/formulas/base/virtual-machines-formula/qvm/default-mgmt-dvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/hide-usb-from-dom0.sls
/srv/formulas/base/virtual-machines-formula/qvm/personal.sls
/srv/formulas/base/virtual-machines-formula/qvm/personal.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-template.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-vm.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu-vm.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu-attach-gpu.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu-detach-gpu.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-vnc-vm.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-vnc.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-vnc.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-audio.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-audio-template.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-audio-vm.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-audio.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-firewall.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-firewall.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-net.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-net.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-usb.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-usb.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/template.jinja
/srv/formulas/base/virtual-machines-formula/qvm/template-gui.jinja
/srv/formulas/base/virtual-machines-formula/qvm/template-whonix-gateway.sls
/srv/formulas/base/virtual-machines-formula/qvm/template-whonix-workstation.sls
/srv/formulas/base/virtual-machines-formula/qvm/untrusted.sls
/srv/formulas/base/virtual-machines-formula/qvm/untrusted.top
/srv/formulas/base/virtual-machines-formula/qvm/updates-via-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/updates-via-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/usb-keyboard.sls
/srv/formulas/base/virtual-machines-formula/qvm/usb-keyboard.top
/srv/formulas/base/virtual-machines-formula/qvm/vault.sls
/srv/formulas/base/virtual-machines-formula/qvm/vault.top
/srv/formulas/base/virtual-machines-formula/qvm/whonix.jinja
/srv/formulas/base/virtual-machines-formula/qvm/whonix-workstation-dvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/work.sls
/srv/formulas/base/virtual-machines-formula/qvm/work.top

%attr(750, root, root) %dir /srv/pillar/base/qvm
%config(noreplace) /srv/pillar/base/qvm/init.sls
%config(noreplace) /srv/pillar/base/qvm/sys-net-as-usbvm.sls
%config(noreplace) /srv/pillar/base/qvm/sys-net-as-usbvm.top
%config(noreplace) /srv/pillar/base/qvm/whonix-testing.sls
%config(noreplace) /srv/pillar/base/qvm/whonix-testing.top
%config(noreplace) /srv/pillar/base/qvm/sys-gui.top
%config(noreplace) /srv/pillar/base/qvm/sys-gui.sls
%config(noreplace) /srv/pillar/base/qvm/sys-gui-as-audiovm.sls
%config(noreplace) /srv/pillar/base/qvm/sys-gui-as-audiovm.top
%config(noreplace) /srv/pillar/base/qvm/sys-gui-gpu.top
%config(noreplace) /srv/pillar/base/qvm/sys-gui-gpu.sls
%config(noreplace) /srv/pillar/base/qvm/sys-gui-vnc.sls
%config(noreplace) /srv/pillar/base/qvm/sys-gui-vnc.top
%config(noreplace) /srv/pillar/base/qvm/sys-usb-allow-mouse.sls
%config(noreplace) /srv/pillar/base/qvm/sys-usb-allow-mouse.top
%config(noreplace) /srv/pillar/base/qvm/usb-keyboard.sls
%config(noreplace) /srv/pillar/base/qvm/usb-keyboard.top
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-net.sls
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-net.top
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-firewall.sls
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-firewall.top
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-usb.sls
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-usb.top
/srv/pillar/base/qvm/init.top

%config(noreplace) /etc/salt/minion.d/formula-virtual-machines.conf

%changelog
* Wed Jan 17 2024 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-mgmt-salt-dom0-virtual-machines.git

* Wed Jan 17 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4123d71
- version 4.1.20

* Sun Jan 14 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7a49022
- Force switching Whonix template for existing sys-whonix/anon-whonix

* Sat Jan 13 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - adf2918
- Rename short whonix-(gw|ws) names to their full names

* Sat Jan 13 2024 Patrick Schleizer <adrelanos@whonix.org> - 1274ed0
- Update whonix.jinja

* Sat Jan 28 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 06093a8
- version 4.1.19

* Sat Jan 28 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bb123b4
- Increase default size of sys-usb

* Wed Jan 25 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 712051f
- Add optional USB keyboard setup also during initial sys-usb setup

* Sun Dec 04 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 83712c4
- version 4.1.18

* Sun Aug 07 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 40be98e
- Add Qubes Builder v2 integration

* Sun Aug 07 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 74b387b
- Running salt into VM is not planned

* Tue Jun 14 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3981e97
- version 4.1.17

* Tue Jun 14 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a6a2b59
- Switch default template to fedora-36

* Tue Jun 14 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - daa4dee
- Fix dummy-psu-sender package name

* Fri Apr 15 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 4be370e
- Drop Travis CI

* Thu Jan 20 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - cc31b15
- Enable usbguard for dom0, when setting up USB keyboard

* Mon Jan 17 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 78dcb14
- version 4.1.16

* Thu Jan 13 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6e57e15
- Exclude controllers listed via rd.qubes.dom0_usb option from sys-usb

* Thu Jan 13 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d851d62
- Add configurable default action for qubes.InputMouse

* Sun Oct 17 2021 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - c3a5e90
- spec: add BR make

* Fri Oct 08 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4af39b4
- version 4.1.15

* Thu Sep 30 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - aea9e37
- Use qvm.template_installed for installing template for sys-gui too

* Thu Sep 16 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1f942d4
- version 4.1.14

* Thu Sep 16 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5ed1278
- Use new qvm.template_installed state

* Sat Sep 11 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a874036
- Install qubes-input-proxy-sender for sys-gui-gpu support

* Sat Sep 11 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 934d452
- version 4.1.13

* Wed Sep 08 2021 Patrick Schleizer <adrelanos@whonix.org> - 7b70b78
- Whonix 16

* Wed Sep 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ee7f9ad
- version 4.1.12

* Thu Aug 19 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f9a76ff
- Enable xscreensaver in Xfce for sys-gui

* Mon Jul 26 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - af23ff0
- sys-gui: drop orphaned xfwm4-theme-nodoka

* Sat Jul 10 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3f1f727
- Switch to fedora-34-xfce as default template for audio/gui

* Wed Jun 23 2021 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 6314acb
- Add VNC GuiVM

* Thu Jun 17 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 56fc1ff
- version 4.1.11

* Sun May 30 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1d20b65
- Do not disable xscreensaver in sys-gui

* Sat May 29 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 67e78e5
- Set up policies for clipboard copy and paste

* Tue May 25 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - edb5394
- sys-gui: do not intercept copy/paste key combos at dom0, let sys-gui see them

* Fri May 21 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e7faff1
- Set a generic 'guivm' and 'audiovm' qvm-service

* Thu May 20 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 99098db
- Include qubes widgets package (qubes-desktop-linux-manager) in GUIVM

* Tue May 04 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 79e9b2b
- Explicitly order sys-usb before user login

* Thu Feb 25 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b75e6c2
- version 4.1.10

* Wed Feb 24 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9dbe0d1
- Switch template for sys-gui and sys-audio to fedora-33(-xfce) too

* Sun Feb 14 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c5e5559
- version 4.1.9

* Sat Feb 13 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 050dcc0
- Switch default template to fedora-33

* Sun Nov 15 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 86178b6
- Add .gitlab-ci.yml

* Tue Oct 13 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 62c888b
- version 4.1.8

* Tue Oct 13 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5ba165b
- Adjust for dummy-psu packages name change

* Sat Oct 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2f18114
- version 4.1.7

* Wed Oct 07 2020 herypt <70331266+herypt@users.noreply.github.com> - 4eb225c
- Support creation of disposable servicevms

* Sat Sep 26 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - c3e00fd
- sys-gui-gpu: setup sys-usb to sys-gui-gpu mouse RPC policy

* Sun Sep 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 094c1e3
- sys-gui-gpu: rename feature for input dom0 devices

* Sun Sep 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 1b3417b
- sys-gui-gpu: use salt for getting first dom0 user

